> ## Documentation Index
> Fetch the complete documentation index at: https://docs.helloannie.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List scheduling availabilities

> Returns available appointment start and end times for a bot and appointment type. Returned startTime and endTime values are whole-second UTC timestamps that can be passed directly to POST /bots/:botId/scheduling/appointments without client-side timezone conversion.



## OpenAPI

````yaml /openapi/openapi.yaml get /bots/{botId}/scheduling/availabilities
openapi: 3.0.3
info:
  title: Annie API
  description: >
    ### Overview


    The Annie API is a (mostly) RESTful API. Typically, both POST bodies and
    responses are JSON-encoded.


    Note: The documenation is Work In Progress and is subject to change.


    ### Base URL


    The base URL for the Annie API is https://api.helloannie.com/.


    Examples in this document may abbreviate this to `/`.


    ### Versioning


    Routes are prefixed with a version number i.e. `v1`. The version will change
    when there is a non-backwards compatible or other significant change to the
    api.


    ### Authentication


    The Annie API supports two authentication methods API Keys and OAuth Access
    Tokens:


    #### API Keys


    API Keys are long-lived tokens that can be generated from the Developer
    Portal on your organization page. API keys are prefixed with `annie-sk-v2-`
    and can be used directly in the `Authorization` header.


    ```

    curl -H "Authorization: Bearer annie-sk-xxxxx"
    https://api.helloannie.com/...

    ```


    #### OAuth Tokens


    OAuth tokens are short-lived access tokens generated using the OAuth 2.0
    Client Credentials flow (Machine-to-Machine). OAuth clients provide scoped
    permissions and are ideal for server-to-server integrations.


    **Creating an OAuth Client**


    OAuth clients can be created in the Developer Portal on your organization
    page. When creating a client, you'll receive:


    - `client_id`: Your OAuth client identifier

    - `client_secret`: Your OAuth client secret (store this securely)


    **Generating an OAuth Token**


    To generate an OAuth access token, make a POST request to the Annie OAuth
    token endpoint:


    **Endpoint:** `https://annie-external-api.us.auth0.com/oauth/token`


    **Example Request:**


    ```bash

    curl -X POST https://annie-external-api.us.auth0.com/oauth/token \
      -H "Content-Type: application/json" \
      -d '{
        "grant_type": "client_credentials",
        "client_id": "your-client-id",
        "client_secret": "your-client-secret",
        "audience": "https://api.helloannie.com"
      }'
    ```


    The `access_token` from the response should be used in the `Authorization`
    header when making requests to the Annie API:


    ```

    curl -H "Authorization: Bearer eyJhbGciOiJSUzI..."
    https://api.helloannie.com/v1/...

    ```


    ### API Response Structure


    The Annie API returns status codes consistent with standard HTTP
    conventions. Success and Error responses follow the below structure:


    ```

    {
      "success": boolean
      "data": {}
      "message": string // optional
    }

    ```


    ### Rate Limiting


    The Annie API enforces rate limits to ensure stability and fair usage. The
    default rate limit is **60 requests per minute** per organization. This
    limit is applied per endpoint pattern (e.g. `GET /v1/bots/:id`).


    When the rate limit is exceeded, the API responds with HTTP `429 Too Many
    Requests`.


    Response headers include:


    - `X-RateLimit-Limit`: The maximum number of requests allowed in the current
    window.

    - `X-RateLimit-Remaining`: The number of requests remaining in the current
    window.

    - `X-RateLimit-Reset`: The time at which the current rate limit window
    resets (in UTC epoch seconds).


    If you exceed the limit, the response will contain a `Retry-After` header
    indicating how many seconds to wait before retrying.


    ### Pagination


    The Annie API does not currently support pagination. All results are
    returned at once.
  version: v1
servers:
  - url: https://api.helloannie.com/v1
security: []
paths:
  /bots/{botId}/scheduling/availabilities:
    get:
      tags:
        - Scheduling
      summary: List scheduling availabilities
      description: >-
        Returns available appointment start and end times for a bot and
        appointment type. Returned startTime and endTime values are whole-second
        UTC timestamps that can be passed directly to POST
        /bots/:botId/scheduling/appointments without client-side timezone
        conversion.
      operationId: getV1BotsByBotIdSchedulingAvailabilities
      parameters:
        - name: botId
          in: path
          required: true
          schema:
            format: uuid
            description: The ID of the bot
            type: string
        - name: appointmentTypeId
          in: query
          required: true
          schema:
            description: >-
              Opaque appointment type ID returned by the appointment-types
              endpoint
            type: string
        - name: startDate
          in: query
          required: true
          schema:
            pattern: ^\d{4}-\d{2}-\d{2}$
            description: Date in YYYY-MM-DD format
            example: '2026-06-15T00:00:00.000Z'
            type: string
        - name: endDate
          in: query
          required: true
          schema:
            pattern: ^\d{4}-\d{2}-\d{2}$
            description: Date in YYYY-MM-DD format
            example: '2026-06-15T00:00:00.000Z'
            type: string
      responses:
        '200':
          description: Response returned when fetching scheduling availabilities
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SchedulingAvailabilitiesResponse'
        '400':
          description: The request was invalid or malformed
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadRequestResponse'
        '403':
          description: You do not have permission to perform this action
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenResponse'
        '404':
          description: The requested resource was not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFoundResponse'
        '500':
          description: An internal server error occurred
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ServerErrorResponse'
components:
  schemas:
    SchedulingAvailabilitiesResponse:
      additionalProperties: false
      type: object
      required:
        - success
        - data
      properties:
        success:
          enum:
            - true
          type: boolean
        data:
          additionalProperties: false
          type: object
          required:
            - availabilities
          properties:
            availabilities:
              type: array
              items:
                additionalProperties: false
                description: >-
                  A single available appointment slot. startTime and endTime can
                  be passed directly to the schedule appointment endpoint
                  without client-side timezone conversion.
                type: object
                required:
                  - startTime
                  - endTime
                properties:
                  startTime:
                    pattern: ^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}Z$
                    description: Whole-second UTC ISO 8601 timestamp ending in Z
                    example: '2026-06-15T20:00:00.000Z'
                    type: string
                  endTime:
                    pattern: ^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}Z$
                    description: Whole-second UTC ISO 8601 timestamp ending in Z
                    example: '2026-06-15T20:00:00.000Z'
                    type: string
    BadRequestResponse:
      additionalProperties: false
      type: object
      required:
        - success
        - data
        - message
      properties:
        success:
          enum:
            - false
          type: boolean
        data:
          additionalProperties: false
          type: object
          properties: {}
        message:
          type: string
    ForbiddenResponse:
      additionalProperties: false
      type: object
      required:
        - success
        - data
        - message
      properties:
        success:
          enum:
            - false
          type: boolean
        data:
          additionalProperties: false
          type: object
          properties: {}
        message:
          type: string
    NotFoundResponse:
      additionalProperties: false
      type: object
      required:
        - success
        - data
        - message
      properties:
        success:
          enum:
            - false
          type: boolean
        data:
          additionalProperties: false
          type: object
          properties: {}
        message:
          type: string
    ServerErrorResponse:
      additionalProperties: false
      type: object
      required:
        - success
        - data
        - message
      properties:
        success:
          enum:
            - false
          type: boolean
        data:
          additionalProperties: false
          type: object
          properties: {}
        message:
          type: string

````